// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: spine/users/group/group.proto

package io.spine.users.group;

/**
 * <pre>
 * Defines roles which a member may have in a group.
 * </pre>
 *
 * Protobuf enum {@code spine.users.group.Role}
 */
public enum Role
    implements com.google.protobuf.ProtocolMessageEnum {
  /**
   * <pre>
   * The role was not specified. A member cannot be added to a group with this value.
   * </pre>
   *
   * <code>ROLE_UNSPECIFIED = 0;</code>
   */
  ROLE_UNSPECIFIED(0),
  /**
   * <pre>
   * A regular member of a group.
   * </pre>
   *
   * <code>MEMBER = 1;</code>
   */
  MEMBER(1),
  /**
   * <pre>
   * A privileged member with permissions to manage the group.
   * </pre>
   *
   * <code>MANAGER = 2;</code>
   */
  MANAGER(2),
  /**
   * <pre>
   * A person who can delete the group and add manage other owners.
   * </pre>
   *
   * <code>OWNER = 3;</code>
   */
  OWNER(3),
  UNRECOGNIZED(-1),
  ;

  /**
   * <pre>
   * The role was not specified. A member cannot be added to a group with this value.
   * </pre>
   *
   * <code>ROLE_UNSPECIFIED = 0;</code>
   */
  public static final int ROLE_UNSPECIFIED_VALUE = 0;
  /**
   * <pre>
   * A regular member of a group.
   * </pre>
   *
   * <code>MEMBER = 1;</code>
   */
  public static final int MEMBER_VALUE = 1;
  /**
   * <pre>
   * A privileged member with permissions to manage the group.
   * </pre>
   *
   * <code>MANAGER = 2;</code>
   */
  public static final int MANAGER_VALUE = 2;
  /**
   * <pre>
   * A person who can delete the group and add manage other owners.
   * </pre>
   *
   * <code>OWNER = 3;</code>
   */
  public static final int OWNER_VALUE = 3;


  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static Role valueOf(int value) {
    return forNumber(value);
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   */
  public static Role forNumber(int value) {
    switch (value) {
      case 0: return ROLE_UNSPECIFIED;
      case 1: return MEMBER;
      case 2: return MANAGER;
      case 3: return OWNER;
      default: return null;
    }
  }

  public static com.google.protobuf.Internal.EnumLiteMap<Role>
      internalGetValueMap() {
    return internalValueMap;
  }
  private static final com.google.protobuf.Internal.EnumLiteMap<
      Role> internalValueMap =
        new com.google.protobuf.Internal.EnumLiteMap<Role>() {
          public Role findValueByNumber(int number) {
            return Role.forNumber(number);
          }
        };

  public final com.google.protobuf.Descriptors.EnumValueDescriptor
      getValueDescriptor() {
    return getDescriptor().getValues().get(ordinal());
  }
  public final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptorForType() {
    return getDescriptor();
  }
  public static final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptor() {
    return io.spine.users.group.GroupProto.getDescriptor().getEnumTypes().get(0);
  }

  private static final Role[] VALUES = values();

  public static Role valueOf(
      com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException(
        "EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private Role(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:spine.users.group.Role)
}

