package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requests creation of a group with an ID which already assigned to another group.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.GroupAlreadyExists}
 */
@Generated("by Spine Model Compiler")
public class GroupAlreadyExists extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private GroupAlreadyExists(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.GroupAlreadyExists messageThrown() {
        return (Rejections.GroupAlreadyExists) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code GroupAlreadyExists} rejection.
     */
    public static class Builder {
        private final Rejections.GroupAlreadyExists.Builder builder = Rejections.GroupAlreadyExists.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the group which the creation command used.
         * </pre>
         */
        public Builder setGroup(GroupId group) {
            builder.setGroup(group);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.GroupAlreadyExists rejectionMessage() {
            Rejections.GroupAlreadyExists message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public GroupAlreadyExists build() {
            return new GroupAlreadyExists(this);
        }
    }
}
