package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requested removal of a group, but it is not a member of a group removal from which
 *  was requested.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.GroupIsNotMember}
 */
@Generated("by Spine Model Compiler")
public class GroupIsNotMember extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private GroupIsNotMember(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.GroupIsNotMember messageThrown() {
        return (Rejections.GroupIsNotMember) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code GroupIsNotMember} rejection.
     */
    public static class Builder {
        private final Rejections.GroupIsNotMember.Builder builder = Rejections.GroupIsNotMember.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The group from which removal of the group was requested.
         * </pre>
         */
        public Builder setParentGroup(GroupId parentGroup) {
            builder.setParentGroup(parentGroup);
            return this;
        }

        /**
         * <pre>
         *  The group removal of whom from the group was requested.
         * </pre>
         */
        public Builder setMissingGroup(GroupId missingGroup) {
            builder.setMissingGroup(missingGroup);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.GroupIsNotMember rejectionMessage() {
            Rejections.GroupIsNotMember message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public GroupIsNotMember build() {
            return new GroupIsNotMember(this);
        }
    }
}
