package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  An operation is not available because a group the passed ID was previously deleted.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.UnavalableForPreviouslyDeletedGroup}
 */
@Generated("by Spine Model Compiler")
public class UnavalableForPreviouslyDeletedGroup extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UnavalableForPreviouslyDeletedGroup(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UnavalableForPreviouslyDeletedGroup messageThrown() {
        return (Rejections.UnavalableForPreviouslyDeletedGroup) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UnavalableForPreviouslyDeletedGroup} rejection.
     */
    public static class Builder {
        private final Rejections.UnavalableForPreviouslyDeletedGroup.Builder builder = Rejections.UnavalableForPreviouslyDeletedGroup.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the group which was previously deleted.
         * </pre>
         */
        public Builder setGroup(GroupId group) {
            builder.setGroup(group);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UnavalableForPreviouslyDeletedGroup rejectionMessage() {
            Rejections.UnavalableForPreviouslyDeletedGroup message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UnavalableForPreviouslyDeletedGroup build() {
            return new UnavalableForPreviouslyDeletedGroup(this);
        }
    }
}
