package io.spine.users.group.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.users.GroupId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requested removal of a user from a group, but the user is not a member of the group.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.group.rejection.UserIsNotMember}
 */
@Generated("by Spine Model Compiler")
public class UserIsNotMember extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UserIsNotMember(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UserIsNotMember messageThrown() {
        return (Rejections.UserIsNotMember) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UserIsNotMember} rejection.
     */
    public static class Builder {
        private final Rejections.UserIsNotMember.Builder builder = Rejections.UserIsNotMember.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The group from which removal of the user was requested.
         * </pre>
         */
        public Builder setGroup(GroupId group) {
            builder.setGroup(group);
            return this;
        }

        /**
         * <pre>
         *  The user removal of whom from the group was requested.
         * </pre>
         */
        public Builder setMissingUser(UserId missingUser) {
            builder.setMissingUser(missingUser);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UserIsNotMember rejectionMessage() {
            Rejections.UserIsNotMember message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UserIsNotMember build() {
            return new UserIsNotMember(this);
        }
    }
}
