package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  An operation is not available because an account with the passed ID was previously deleted.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.UnavalableForPreviouslyDeletedAccount}
 */
@Generated("by Spine Model Compiler")
public class UnavalableForPreviouslyDeletedAccount extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UnavalableForPreviouslyDeletedAccount(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UnavalableForPreviouslyDeletedAccount messageThrown() {
        return (Rejections.UnavalableForPreviouslyDeletedAccount) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UnavalableForPreviouslyDeletedAccount} rejection.
     */
    public static class Builder {
        private final Rejections.UnavalableForPreviouslyDeletedAccount.Builder builder = Rejections.UnavalableForPreviouslyDeletedAccount.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the account which existed before.
         * </pre>
         */
        public Builder setAccount(UserId account) {
            builder.setAccount(account);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UnavalableForPreviouslyDeletedAccount rejectionMessage() {
            Rejections.UnavalableForPreviouslyDeletedAccount message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UnavalableForPreviouslyDeletedAccount build() {
            return new UnavalableForPreviouslyDeletedAccount(this);
        }
    }
}
