package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requested deletion of a user account,
 *  but the account is already marked as deleted.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.UserAccountAlreadyDeleted}
 */
@Generated("by Spine Model Compiler")
public class UserAccountAlreadyDeleted extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UserAccountAlreadyDeleted(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UserAccountAlreadyDeleted messageThrown() {
        return (Rejections.UserAccountAlreadyDeleted) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UserAccountAlreadyDeleted} rejection.
     */
    public static class Builder {
        private final Rejections.UserAccountAlreadyDeleted.Builder builder = Rejections.UserAccountAlreadyDeleted.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the account.
         * </pre>
         */
        public Builder setAccount(UserId account) {
            builder.setAccount(account);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UserAccountAlreadyDeleted rejectionMessage() {
            Rejections.UserAccountAlreadyDeleted message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UserAccountAlreadyDeleted build() {
            return new UserAccountAlreadyDeleted(this);
        }
    }
}
