package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requested creation of a new user account,
 *  but the account with such ID already exists.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.UserAccountAlreadyExists}
 */
@Generated("by Spine Model Compiler")
public class UserAccountAlreadyExists extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UserAccountAlreadyExists(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UserAccountAlreadyExists messageThrown() {
        return (Rejections.UserAccountAlreadyExists) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UserAccountAlreadyExists} rejection.
     */
    public static class Builder {
        private final Rejections.UserAccountAlreadyExists.Builder builder = Rejections.UserAccountAlreadyExists.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the account.
         * </pre>
         */
        public Builder setAccount(UserId account) {
            builder.setAccount(account);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UserAccountAlreadyExists rejectionMessage() {
            Rejections.UserAccountAlreadyExists message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UserAccountAlreadyExists build() {
            return new UserAccountAlreadyExists(this);
        }
    }
}
