package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  A command requested suspension of a user account,
 *  but the account is already suspended.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.UserAccountAlreadySuspended}
 */
@Generated("by Spine Model Compiler")
public class UserAccountAlreadySuspended extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UserAccountAlreadySuspended(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UserAccountAlreadySuspended messageThrown() {
        return (Rejections.UserAccountAlreadySuspended) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UserAccountAlreadySuspended} rejection.
     */
    public static class Builder {
        private final Rejections.UserAccountAlreadySuspended.Builder builder = Rejections.UserAccountAlreadySuspended.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID of the account.
         * </pre>
         */
        public Builder setAccount(UserId account) {
            builder.setAccount(account);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UserAccountAlreadySuspended rejectionMessage() {
            Rejections.UserAccountAlreadySuspended message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UserAccountAlreadySuspended build() {
            return new UserAccountAlreadySuspended(this);
        }
    }
}
