package io.spine.users.user.rejection;

import io.spine.base.ThrowableMessage;
import io.spine.core.UserId;
import io.spine.validate.Validate;
import javax.annotation.Generated;

/**
 * <pre>
 *  An operation requested by a command is not available for an account which is marked
 *  as deleted. Or, the account with such ID was never created.
 * </pre>
 *
 * Rejection based on proto type {@code io.spine.users.user.rejection.UserAccountDoesNotExist}
 */
@Generated("by Spine Model Compiler")
public class UserAccountDoesNotExist extends ThrowableMessage {
    private static final long serialVersionUID = 0L;

    /**
     * Creates a new instance.
     *
     * @param builder the builder for the rejection
     */
    private UserAccountDoesNotExist(Builder builder) {
        super(builder.rejectionMessage());
    }

    @Override
    public Rejections.UserAccountDoesNotExist messageThrown() {
        return (Rejections.UserAccountDoesNotExist) super.messageThrown();
    }

    /**
     * @return a new builder for the rejection
     */
    public static Builder newBuilder() {
        return new Builder();
    }

    /**
     * The builder for the {@code UserAccountDoesNotExist} rejection.
     */
    public static class Builder {
        private final Rejections.UserAccountDoesNotExist.Builder builder = Rejections.UserAccountDoesNotExist.newBuilder();

        /**
         * Prevent direct instantiation of the builder.
         */
        private Builder() {
        }

        /**
         * <pre>
         *  The ID that the command used to reference the account.
         * </pre>
         */
        public Builder setAccount(UserId account) {
            builder.setAccount(account);
            return this;
        }

        /**
         * Obtains the rejection and validates it.
         */
        private Rejections.UserAccountDoesNotExist rejectionMessage() {
            Rejections.UserAccountDoesNotExist message = builder.build();
            Validate.checkValid(message);
            return message;
        }

        /**
         * Creates the rejection from the builder and validates it.
         */
        public UserAccountDoesNotExist build() {
            return new UserAccountDoesNotExist(this);
        }
    }
}
